#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "pgm.h"

main(int argc, char* argv[])
{

  int width, height, max;
  int i;
  int size;
  long r255;
  double r1;
  double sig=0, fraction = 10;
  long rand1, rand256;

  unsigned char *in_image, *out_image;

  max=read_pgm(argv[1], &in_image, &width, &height);
  size=width*height;

  i=0;
  while (argv[2][i]!=0 && argv[2][i]!='.')
  {
    sig = sig*10.0+(double)(argv[2][i++]-48);
  printf("sig = %g\n", sig);
  }

  if (argv[2][i]=='.') i++;

  while (argv[2][i]!=0)
  {
    sig+=((double)(argv[2][i++]-48)/fraction);
    fraction/=10;
  printf("sig = %g\n", sig);
  }
  printf("sig = %g\n", sig);

  out_image = (unsigned char *) calloc(size, 1);

  srandom(30029);
  random();
  for(i=0; i<size; i++)
  {
    r1 = (double)(random()%10000)/9999.0;
    r255 = random()%512-256;
    /*printf("r1=%g, rand256=%d, r255=%d\n", r1, rand256, r255);*/
    while( (r1==0) || 
           (r1>exp(-(r255*r255)/(2*sig*sig))) ||
           (in_image[i]+r255<0) || 
           (in_image[i]+r255>255) )
    {
      r1 = (double)(random()%10)/10.0;
      r255 = random()%512-256;
    }
    out_image[i] = in_image[i]+r255;
  }

  write_pgm(argv[3], out_image, width, height, max, "");
}
